Mantis Bugtracker          
testlink.org

View Issue Details Jump to Notes ] Issue History ] Print ]
IDProjectCategoryView StatusDate SubmittedLast Update
0007466TestLinkAPI - XMLRPCpublic2016-03-14 11:142016-09-08 15:13
Reporteranton7811 
Assigned Tofman 
PrioritynormalSeveritymajorReproducibilityrandom
StatusclosedResolutionfixed 
PlatformLinuxOSScientific LinuxOS Version7.1
Product Version1.9.14 (2015 Q3) 
Fixed in Version1.9.15 (2015 Q4) 
Summary0007466: Different test cases may have the same external test case ID
DescriptionI had already 4 situations when two users were adding tests to TestLink using XMLRPC API at the same time and those test cases have duplicated external IDs.
Creation time of test cases is the same including seconds.

This causes problem in using API for test case updating, results reporting in future.
TagsNo tags attached.
Database (MySQL,Postgres,etc)mysql (mariadb)
Browser
PHP Versionphp-5.4.16-36.el7_1.x86_64
TestCaseID
QA Team - Task Workflow StatusREADY FOR TESTING
Attached Filestar file icon tlo.tar [^] (108,032 bytes) 2016-03-14 21:10

- Relationships
child of 0007262closedfman Availables hot-fixes for 1.9.14 & How To get full fixed package from GitHub 

-  Notes
(0024596)
fman (administrator)
2016-03-14 19:28

Details are not enough, issue can be related to concurrency
(0024598)
fman (administrator)
2016-03-14 21:09

would you mind to try with attached code,and provide feedback ?
(0024604)
anton7811 (reporter)
2016-03-15 13:50

Thank you!
Will try it. But first I'll try to find steps to reproduce on my test server. So I'll be able to verify your code.

For existing test cases in production DB as I understand I can only remove and add them again to recreate external IDs.
(0024607)
anton7811 (reporter)
2016-03-15 18:23

Thanks! Fix works!

I created a script to add two test cases in parallel using python and multiprocessing.

### Without fix: One subprocess raise an error but both tests were added to testlink with the same ext ID.

  File "lib/python2.7/xmlrpclib.py", line 558, in feed
    self._parser.Parse(data, 0)
ExpatError: junk after document element: line 1, column 91

### With fix: No error. Tests added to testlink with different IDs.
(0024608)
fman (administrator)
2016-03-15 19:59

Thanks! going to add to main line of code
(0024610)
fman (administrator)
2016-03-15 20:20

https://github.com/TestLinkOpenSourceTRMS/testlink-code/commit/4d453caef3e8ee243630fb6ecdba45558b9b9826 [^]
(0025274)
fman (administrator)
2016-09-08 15:13

1.9.15 Released - 2016-09-08

- Issue History
Date Modified Username Field Change
2016-03-14 11:14 anton7811 New Issue
2016-03-14 19:28 fman Note Added: 0024596
2016-03-14 21:09 fman Note Added: 0024598
2016-03-14 21:10 fman File Added: tlo.tar
2016-03-14 21:10 fman Assigned To => fman
2016-03-14 21:10 fman Status new => feedback
2016-03-15 13:50 anton7811 Note Added: 0024604
2016-03-15 13:50 anton7811 Status feedback => assigned
2016-03-15 18:23 anton7811 Note Added: 0024607
2016-03-15 19:59 fman Note Added: 0024608
2016-03-15 20:19 fman QA Team - Task Workflow Status => READY FOR TESTING
2016-03-15 20:19 fman Fixed in Version => 1.9.15 (2015 Q4)
2016-03-15 20:19 fman Relationship added child of 0007262
2016-03-15 20:20 fman Note Added: 0024610
2016-03-15 20:20 fman Status assigned => resolved
2016-03-15 20:20 fman Resolution open => fixed
2016-09-08 15:13 fman Note Added: 0025274
2016-09-08 15:13 fman Status resolved => closed



Copyright © 2000 - 2018 MantisBT Team
Powered by Mantis Bugtracker